%function [x,phat,w_hat,Amat,row] = ComputeLocalLinear(y,X,Hmat,fvec,Amat,bvec,Aeq,beq,x,v_pt,v_mt,row,Aymat,fp_Aymat,Amat_monotone,Aymat_obs)
function [x,phat,Amat,row] = ComputeLocalLinear(y,X,Hmat,fvec,Amat,bvec,Aeq,beq,x,v_pt,v_mt,row,Aymat,fp_Aymat,Amat_monotone,Aymat_obs)
n = size(y,1);
d = size(X,2); 


%%Add violated constraints 
for i = 1:size(v_pt,1)
    Amat(row,:) = -(fp_Aymat(:,:,v_pt(i,1))'*(x(v_pt(i,2),:)-x(v_pt(i,1),:))'-(Aymat(v_pt(i,2),:)'-Aymat(v_pt(i,1),:)'));
    row = row + 1;
end

bvec=zeros(row-1,1);

%%cvx problem
cvx_begin quiet

    variable p_hat(n) %nonnegative
    SSR = 0;
    for i = 1:n,
        ghat = 0;
        for j = 1:n,
            ghat = ghat + p_hat(j)*Aymat_obs(i,j);
        end
        SSR = SSR + (y(i) - ghat)^2;
    end
    minimize(SSR)
    
    subject to
    for i = 1:(row-1)
       %Amat(i,:)*w_hat <= bvec(i);
       Amat(i,:)*p_hat <= bvec(i);
    end
    sum(p_hat)==1; 
    
    
cvx_end

%phat = w_hat+repmat(1/n,n,1);
phat = p_hat;
sum(phat)

%Print out the number of terms in objective function and constraints we used in Afriat inequality
max_cnt_cnst = length(x)*length(x)-length(x); 
fprintf('Number of constrains used: %d/%d\n',row-1,max_cnt_cnst);

end
