clear
% cd ('\\tarzan1\graduate$\yakkun19\Downloads\cvx')
% cvx_setup \\tarzan1\graduate$\yakkun19\Downloads\cvx\cvx_license.dat
% cvx_solver gurobi
% cvx_save_prefs

%warning('off','all')
%warning


%%Global Settings%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Experiment for univariate(=1) or multivariate(=2)?
%num_var = [2;3;4];
num_var = 3;

%1:gaussian, 2:uniform, 3:epanechnikov
kernel = 1;

%Give the value of bandwidth. When h=0, we use optimal bandwidth suggested by Bowman and Azzalini
h=0;
%h=[1.071071,0.8987191];

%Number of observations
n = [100;200;300;400;500];
%n = 100;

%Num of grid points for estimation. Large grid points make calculation longer, but the graph smoother. 
%grid_point = 25;
grid_point =[100;200;300;400;500];

%Sum of exponent of Cobb Douglas function
%sum_exp = [0.4;0.8];
sum_exp = 0.8;

%Variance of the error term%sigma = [0.7;1.4];
%sigma = [0;1.4];
sigma = 0.7;

%Min and Max of observed X
minx_unif=1;
maxx_unif=10;

%Random data or fixed data? (0: fixed data, 1: random data)
random = 0;

%Additive or Multiplicative? (0: Additive, 1:multiplicative)
error_model = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Use same number of grid as number of observations? (0:no, 1:yes)
SameGridObs = 0;

%Bandiwidth selection method, 1:Rule-of-Thumb , 2:Leave-one-out CV , 3:10-fold CV
selection = 2;

%Debug purpose: Select Particular Experiment to see the result (Default = 0)
select_exp = 0;

%Number of simulation
NumSimu = 1;
SumMSEobs=zeros(length(sum_exp)*length(num_var)*length(n)*length(sigma)*length(grid_point),1);
SumMSEgrd=zeros(length(sum_exp)*length(num_var)*length(n)*length(sigma)*length(grid_point),1);
SumTime1 = zeros(length(sum_exp)*length(num_var)*length(n)*length(sigma)*length(grid_point),1);
SumTime2 = zeros(length(sum_exp)*length(num_var)*length(n)*length(sigma)*length(grid_point),1);
AveMSEobs=zeros(length(sum_exp)*length(num_var)*length(n)*length(sigma)*length(grid_point),1);
AveMSEgrd=zeros(length(sum_exp)*length(num_var)*length(n)*length(sigma)*length(grid_point),1);
AveTime1 = zeros(length(sum_exp)*length(num_var)*length(n )*length(sigma)*length(grid_point),1);
AveTime2 = zeros(length(sum_exp)*length(num_var)*length(n )*length(sigma)*length(grid_point),1);


for Simu = 1:NumSimu

experiment_number = 1
for i = 1:length(sum_exp)
    for j = 1:length(num_var)
        for k = 1:length(n)
            for l = 1:length(sigma)
                for m = 1:length(grid_point)
                    if SameGridObs == 1
                        grid_point=n(k);
                    end
                    if select_exp==0 | experiment_number == select_exp
                        [MSE(experiment_number,1),MSE(experiment_number,2), t1(experiment_number),t2(experiment_number),grd_drop(experiment_number),flagBW(experiment_number)] = LLKwSCtest(sum_exp(i),num_var(j),n(k),sigma(l),kernel,h,grid_point(m),minx_unif,maxx_unif,selection,random,error_model);
                        Setting(experiment_number,:) = [sum_exp(i),num_var(j),n(k),sigma(l)];
                    end
                    experiment_number = experiment_number + 1    
                end
            end
        end
    end
end


SumMSEobs = SumMSEobs + MSE(:,1);
SumMSEgrd = SumMSEgrd + MSE(:,2);
SumTime1 = SumTime1 + t1';
SumTime2 = SumTime2 + t2';

fprintf('Du''s model');
%[Setting, MSE, grd_drop', t', flagKNN']
final=[MSE, grd_drop', t1', t2', flagBW']
mypath = 'E:\Directed Study\Nonparametric estimation method\MATLAB\Experiments\Du''s model y space\LL cvx';
Filename = ['Results_3Du_a' num2str(Simu,'%02u') '.csv'];
csvwrite(fullfile(mypath,Filename),final);

end

AveMSEobs = SumMSEobs/NumSimu;
AveMSEgrd = SumMSEgrd/NumSimu;
AveTime1 = SumTime1/NumSimu;
AveTime2 = SumTime2/NumSimu;

final = [AveMSEobs, AveMSEgrd, AveTime1, AveTime2]
mypath = 'E:\Directed Study\Nonparametric estimation method\MATLAB\Experiments\Du''s model y space\LL cvx';
Filename = 'Results_Du3.csv'
csvwrite(fullfile(mypath,Filename),final);


